<template>
    <div class="app">
        <h2 class="text-center mt-4 mb-4 text">Crud WorkingTime</h2>
        <div class="container-fluid">
            <div class="table-responsive">
                <table class="table">
                    <thead class="thead-dark">
                        <tr>
                            <th v-for="column in columns" class="text">
                                {{column}}
                            </th>
                        </tr>
                    </thead>
                    <tbody class="text">
                        <tr v-for="(time) in times">
                            <td class="text-center">{{time.id}}</td>
                            <td>
                                <span v-show="!isEditing">{{time.start}}</span>
                                <input v-show="isEditing" placeholder="Start" v-model="time.start" type="text">
                            </td>
                            <td>
                                <span v-show="!isEditing">{{time.end}}</span>
                                <input v-show="isEditing" placeholder="End" v-model="time.end" type="text">
                            </td>
                            <td>
                                <div>
                                    <a v-show="!isEditing" href="#!" @click="updateTime()" class="btn btn-warning">Edit</a>
                                    <a v-show="!isEditing" href="#!" @click="deleteTime(time)" class="btn btn-danger">Delete</a>
                                    <a v-show="isEditing" href="#!" @click="saveTime(time)" class="btn btn-primary">Save</a>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <div class="text">#</div>
                            </td>
                                <td>
                                    <div class="input-field">
                                        <input placeholder="Start" v-model="input.start" id="start" type="text">
                                    </div>
                                </td>
                            <td>
                                <div class="input-field">
                                    <input placeholder="End" v-model="input.end" id="end" type="text">
                                </div>
                            </td>
                            <td>
                                <a href="#!" @click="createTime" class="btn btn-success"><i class="material-icons">Add</i></a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    </template>
    
    <script>
    import moment from 'moment'
    export default {
        mounted(){
            if (localStorage.getItem('id')) {
                this.user.id = localStorage.getItem('id')
                this.user.token = localStorage.getItem('token')
            }
            this.fetchTimes()
        },
        data() {
            return {
                user: {
                    id: "",
                    token: "",
                    role: ""
                },
                columns: [
                    "Id",
                    "Start",
                    "End",
                    "Actions "
                ],
                times: [],
                input: {
                    start: "",
                    end: ""
                },
                isEditing: false,
            }
        },
        methods : {
            format_date(value){
                if (value) {
                    return moment(String(value)).format('YYYY-MM-DD HH:mm:ss')
                }
            },
            async fetchTimes() {
                const url = 'http://localhost:4000/api/workingtimes/' + this.user.id
                let result = await (await fetch(url, {
                    method: 'GET',
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                        'Authorization': `Bearer ${this.user.token}`
                    },
                })).json()
                this.times = result.data
                for (let time of this.times) {
                    time.start = this.format_date(time.start),
                    time.end = this.format_date(time.end)
                }
            },
            async createTime() {
                const url = 'http://localhost:4000/api/workingtimes/' + this.user.id
                await fetch(url, {
                    method: 'POST',
                    headers: {
                        'Accept': 'application/json',
                        'Content-type': 'application/json',
                        'Authorization': `Bearer ${this.user.token}`
                    },
                    body: JSON.stringify({
                        workingtime: {
                            start: this.input.start,
                            end: this.input.end,
                        }
                    })
                })
                await this.fetchTimes()
                this.input.start = "";
                this.input.end = "";
                this.$emit('updateCharts')
            },
            async updateTime() {
                this.isEditing = true;
            },
            async saveTime(time) {
                this.isEditing = false;
                const url = 'http://localhost:4000/api/workingtimes/' + time.id
                let newStart = time.start
                let newEnd = time.end
                await fetch(url, {
                    method: 'PUT',
                    headers: {
                        'Accept': 'application/json',
                        'Content-type': 'application/json',
                        'Authorization': `Bearer ${this.user.token}`
                    },
                    body: JSON.stringify({
                        workingtime: {
                            start: newStart,
                            end: newEnd
                        }
                    })
                })
                await this.fetchTimes()
                this.$emit('updateCharts')
            },
            async deleteTime(time) {
                const url = 'http://localhost:4000/api/workingtimes/' + time.id
                await fetch(url, {
                    method: 'DELETE',
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                        'Authorization': `Bearer ${this.user.token}`
                    },
                })
                await this.fetchTimes()
                this.$emit('updateCharts')
            },
        }
    }
    </script>

<style>

.text{
  color: aliceblue;
}

</style>